#include "cll1.h"

/* This is C<<1 rewrite of object polymorphism from
   http://en.wikipedia.org/wiki/Polymorphism_in_object-oriented_programming */

def_type(Animal);

def_mem(Actions)
{
 void method(init) (Animal self, str name);
 str method(talk) (Animal self);
};

def_obj(Animal)
{
 interface(Actions);
 char *name;
};

Animal construct(Animal) (Animal self, str name)
{
 self->name = name;
 return self;
}

str cat_talk(Animal self)
{
 return "Meow!";
}

str dog_talk(Animal self)
{
 return "Arf! Arf!";
}

Actions cat_actions(void)
{
 Actions this=get_mem(Actions);
 this->talk = cat_talk;
 return this;
}

Actions dog_actions(void)
{
 Actions this=get_mem(Actions);
 this->talk = dog_talk;
 return this;
}

program
{
 int i;
 Animal animal[3];
 Actions cat = cat_actions();
 Actions dog = dog_actions();

 animal[0] = get_obj(Animal, cat, "Missy");
 animal[1] = get_obj(Animal, cat, "Mr. Bojangles");
 animal[2] = get_obj(Animal, dog, "Lassie");

 for_range(i, 0, 2)
 {
  printf("%s: %s\n", animal[i]->name, _(talk, animal[i]));
 }
}
